inc += include_directories('.')

headers = [ 
  'adapter/adapter.hpp',

  'utils/fft/fft.hpp',
  'utils/fft/rdft.hpp',
  'utils/cvec/cvec.hpp',
  'utils/fvec/fvec.hpp',
  'utils/real_time/real_time.hpp',
  'utils/workers/plugin.hpp',
  'utils/workers/result.hpp',
  'utils/workers/setup.hpp',
  'utils/windows/hann/hann.hpp',

  # plugins
  'plugins/magnitude/magnitude.hpp',

  'harmonica.hpp'
]

sources = [ 
  'utils/real_time/real_time.cpp',
  'utils/cvec/cvec.cpp',
  'utils/fvec/fvec.cpp',

  'utils/windows/hann/hann.cpp',

  # plugins
  'plugins/magnitude/magnitude.cpp',
]

lib = library(
  meson.project_name(), 
  include_directories : inc,
  sources: [headers, sources],
  dependencies : deps,
  cpp_args: args
)

harmonica_sdk_dep = declare_dependency(
  include_directories: inc, 
  link_with: lib 
)

deps += harmonica_sdk_dep
